unit TypFileHandle;

interface

uses dialogs, sysutils;

type
  string25 = string[25];
  PWordsrec = ^TWordsrec;
  TWordsRec = record
    label1: string[25];
//    telNo: string[10];
  end;
  Pindexrec = ^Tindexrec;
  Tindexrec = record
    label1: string[25];
    Recordpos: longint;
  end;
//  file://Procedure to open the files.
  procedure initialize(const Words,ind,del:string);
  Procedure done;
//Tstrings
//  file://Procedures to handle the files for us.
  function  Wordsfile_addrecord(var rec:TWordsrec):longint;
  Procedure indexfile_addrecord(var rec:Tindexrec);
  procedure Wordsfile_deleterecord(currentpos:integer);
  procedure indexfile_deleterecord(const rec:string25);
  function  indexfile_findrecord(const name:string25):longint;
  procedure delfile_addrecord(var rec:longint);
  procedure delfile_deleterecord;
  // main procedures and functions;

  procedure addrecord(var rec:TWordsrec);
  procedure deleterecord(var rec:TWordsrec);
  procedure savechanges(var rec:tWordsrec);
//  function  findrecord(name : string25):TWordsrec;
  function  findrecord(name : string25): Boolean;

var
  Wordsfile  : file of TWordsrec;
  indexfile  : file of Tindexrec;
  Delfile    : file of longint;

implementation

procedure initialize(const Words, ind, del:string);
var
  Wordsfileexists : boolean;
  indexfileexists : boolean;
  delfileexists   : boolean;
begin
  assignfile(Wordsfile,Words);
  assignfile(indexfile,ind);
  assignfile(delfile,del);
  {
   checking to see if the files have been opened succesfuly
   else create them or whatever you want to do
   Idea
   You can examine if there is the index file present and yield for
   file destruction.
  }
{  Wordsfileexists := not (ioresult = 0);
  indexfileexists := not (ioresult = 0);
  delfileexists := not (ioresult = 0);}
//  if not Wordsfileexists then rewrite(Wordsfile)
  if not FileExists(Words) then
     rewrite(Wordsfile)
  else reset(Wordsfile);
//  if not indexfileexists then rewrite(indexfile)
  if not FileExists(ind) then
     rewrite(indexfile)
  else reset(indexfile);
//  if not delfileexists then rewrite(delfile)
  if not FileExists(del) then
     rewrite(delfile)
  else reset(delfile);
end;

function Wordsfile_addrecord(var rec:TWordsrec):longint;
var
  temppos:longint;
  Buffer: TWordsrec;
  tmp: string25;
begin
//  file://if there are deleted records then replace the first found
{cette procdure consiste  remplacer l'enr supprim (marqu seulement)
par le nouvel enregistrement.
donc le programme cherchera  remplacer d'abord les enregistrements marqus, avant
d'ajouter dans le fichier.
puis, il ira supprimer l'enregistrement marqu dans le fichier delfile}
  if filesize(delfile)>0 then
  begin
    seek(delfile,0);//goto start of file.
    read(delfile,temppos);// get the first deleted record available
    seek(Wordsfile,temppos);//go to the deleted record
{rajout par DC}
    read(Wordsfile, buffer);
    if buffer.label1[1] = #4 then
       delete(buffer.label1, 1, 1);
    seek(Wordsfile, temppos);
{fin rajout}
    write(Wordsfile,rec); //file://replace the deleted record;
{rajout DC}
    delfile_deleterecord;
    indexfile_deleterecord(buffer.label1);
    result:=temppos;
  end
  else//if not then append file with new record
  begin
    system.seek(Wordsfile,filesize(Wordsfile));//go to the end of file
    result:=filesize(Wordsfile);
    {the filesize returns the number of blocks in the file in a
    typed file 1 block = sizeof(recordtype)}
    write(Wordsfile,rec);//write the new record;
  end;
end;

Procedure indexfile_addrecord(var rec:Tindexrec);
var
  inf, sup, pos: longint;
  readb: Tindexrec;
  bool: boolean;
  buff: Array[boolean] of Tindexrec;
begin
{rajout par DC}
   if filesize(indexfile) = 0 then
      write(indexfile, rec)
   else begin
//   file://use the binary search method to point to the right position in the
//file for the record to be inserted.
   inf := 1;
   sup := filesize(indexfile);
   repeat
     pos := (inf + sup) div 2;
     seek(indexfile, pos-1);
     read(indexfile, readb);
     if rec.label1 < readb.label1 then
        sup := pos -1
     else
        inf := pos +1;
   until {(sup-inf=1) or }(inf>sup) or (rec.label1=readb.label1);
  {
   I'm keeping the key unique to avoid confusion for the first time

   Check to see if the previus loop exited because we reached the
   apropriate position or because there is an other record with
   the same name
  }
   if rec.label1=readb.label1 then
      showmessage('Duplicated key')
   else //file://If key doesn't exists then actually the sup -inf equals 1
   begin // here begins the append;
{     seek(indexfile,inf); //file://goto inf pos;
     read(indexfile,readb);}//read the record
//     file://check to see if the inf is the position to insert if not then
//the sup is.
//     if rec.label1 < readb.label1 then
        pos:=inf;
{     else
        pos:=sup;}

     seek(indexfile, pos-1); {se positionne  l'emplacement de readb, ou devra tre insr rec
{     read(indexfile,readb); {lit readb = proch1
     read(indexfile,writeb); {lit writeb = proch2
     inf:=pos;
     sup:=filepos(indexfile); {sup = aprs proch2
     seek(indexfile,inf); {se positionne  l'emplacement de readb, ou devra tre insr rec
     write(indexfile,rec); {crit rec
     inf:=filepos(indexfile);
     seek(indexfile,inf); {se positionne aprs rec
     write(indexfile,readb); {crit proch1
     inf:=filepos(indexfile); {inf = aprs nouv proch1
     repeat
       seek(indexfile,sup); {positionne aprs proch2
       read(indexfile,readb); {lit proch3
       sup:=filepos(indexfile);

       seek(indexfile,inf); {positionne aprs proch1
       write(indexfile,writeb); {crit proch2
       inf:=filepos(indexfile); {inf = aprs proch2

       seek(indexfile,sup); {positionne aprs proch3
       read(indexfile,writeb); {lit proch4
       sup:=filepos(indexfile); {sup = aprs proch4

       seek(indexfile,inf); {positionne aprs proch2
       write(indexfile,readb); {crit proch3
       inf:=filepos(indexfile); {inf = aprs proch3

     until eof(indexfile);
     write(indexfile,writeb); {crit proch4
   end;}
   bool := true;
   buff[bool] := rec;
   if eof(indexfile) then begin
      write(indexfile, buff[bool]);
      exit;
   end;
   while not eof(indexfile) do begin
      bool := not bool;
      inf := filepos(indexfile);
      read(indexfile, buff[bool]);
      seek(indexfile, inf);
      write(indexfile, buff[not bool]);
   end;
   write(indexfile, buff[bool]);
   end
   end
end;

{tentative solution:

buffer0 := rec,
si eof, j'cris buffer0, exit
(*while not eof*)
je lis proch1, 2
buffer1/0 := proch1, 2
je reviens au dbut de proch1, 2
j'cris buffer0/1,
(* fin while *)
j'cris buffer1/0

je lis proch2, 4
buffer0 := proch2, 4
je reviens au dbut de proch2, 4
j'cris buffer1,
(* fin while *)
finally
j'cris buffer0

fin}

procedure Wordsfile_deleterecord(currentpos:integer);
var
  temp:TWordsrec;
begin
  system.seek(Wordsfile,currentpos);
//  file://read the current record places the file cursor to next one
  read(Wordsfile,temp);
//  file://make the first character a dummy one to determine the deleted records
  temp.label1:=#4+temp.label1;
  seek(Wordsfile,currentpos);
  write(Wordsfile,temp);
  delfile_addrecord(currentpos);
  {
  You don't actually delete any record in the Words file because
  it is not sorted and you must keep the index sorted based on the
  record position in the file to be able to access the right record.
  You keep the deleted records in an external file to overwrite
  them inserting a new one on top  to keep the filesize at minimum.
  This gives the change to create an undelete routine if you want.
  }
end;

{procdure  revoir -tester avec le btn 'deleteindex'-}
procedure indexfile_deleterecord(const rec:string25);
var
  writepos  : longint;
  readpos   : longint;
  buffer : Tindexrec;
  currentpos:longint;
begin
  currentpos:=indexfile_findrecord(rec);
  if currentpos<>-1 then
  begin
    seek(indexfile, currentpos);
    read(indexfile, buffer);
    buffer.Recordpos := -1;
    seek(indexfile, currentpos);
    write(indexfile, buffer);
{  seek(indexfile,currentpos);
  writepos:=filepos(indexfile);
  readpos:=writepos+1;
  seek(indexfile,readpos);
  read(indexfile,buffer);
  repeat
    seek(indexfile,readpos);
    read(indexfile,buffer);
    seek(indexfile,writepos);
    write(indexfile,buffer);
    inc(writepos);
    inc(readpos);
  until eof(indexfile);
  seek(indexfile,filesize(indexfile)-1);
  Truncate(indexfile);}
  end
  else showmessage('Record not found');
end;

function indexfile_findrecord(const name:string25):longint;
var
  inf, sup, pos :longint;
  buffer:Tindexrec;
begin
   if filesize(indexfile) = 0 then
     result := -1
   else begin
   inf := 1;
   sup := filesize(indexfile);
   repeat
     pos := (inf + sup) div 2;
     seek(indexfile, pos-1);
     read(indexfile, buffer);
     if name < buffer.label1 then
        sup := pos -1
     else
        inf := pos +1;
   until {(sup-inf=1) or }(inf>sup) or (name = buffer.label1);
   if buffer.label1 = name then
      result:=filepos(indexfile)-1
   else result:=-1;
   if buffer.Recordpos = -1 then
//      showmessage('deleted record /'+name);
   end
{  if filesize(indexfile) > 0 then begin
  inf:=0;
  sup:=filesize(indexfile);
  repeat
    seek(indexfile,(inf+sup) div 2);
    read(indexfile,buffer);
    if buffer.label1< name then inf:=filepos(indexfile)-1
    else
    if buffer.label1> name then sup:=filepos(indexfile)-1;
  until (sup-inf=1) or (inf>=sup) or (buffer.label1=name);
  if buffer.label1<>name then result:=-1
  else result:=filepos(indexfile)-1
  end else result := -1;}
end;

procedure delfile_addrecord(var rec:longint);
begin
  {
  in this file we will use the fifo method to overwrite the
  oldest deleted record in the file
  so any input will bee done at the end of the file and any delete
  will be done at the begining.No chekcing is done for tha reson.
  }
  seek(delfile,filesize(delfile));
  write(delfile,rec);
end;

{cette procdure consiste  tout dcaler vers le bas, pour viter le fifo
lors de l'effacement.}
procedure delfile_deleterecord;
var
  writepos,readpos  : longint;
  buffer:longint;
begin
  {
  In this procedure because of the fifo method the delete will only
happen
  at the begining of the table this is been taken care in
  the Wordsfile_addrecord,Wordsfile_deleterecord procedures.
  }
  readpos := 1;
  buffer:=0;
  writepos:=0;
//  seek(delfile,0);
//  repeat
  while readpos < filesize(delfile) do begin
    seek(delfile,readpos);
    read(delfile,buffer);
    seek(delfile,writepos);
    write(delfile,buffer);
    inc(writepos);
    inc(readpos);
//  until readpos>=filesize(delfile);
  end;
  {dans ce cas, le dernier enregistrement apparatra en double.
  c'est pourquoi on le supprimera}
  seek(delfile,filesize(delfile)-1);
  truncate(delfile);
end;

procedure addrecord(var rec:TWordsrec);
var
  indrec:Tindexrec;
begin
  if indexfile_findrecord(rec.label1)>-1 then
{ractiver ceci aprs les importations
    showmessage('Duplicated key')}
  else
  begin
    indrec.label1 := rec.label1;
    indrec.Recordpos := Wordsfile_addrecord(rec);
    indexfile_addrecord(indrec);
  end
end;

procedure deleterecord(var rec:TWordsrec);
var
  indrec:Tindexrec;
begin
  seek(indexfile,indexfile_findrecord(rec.label1));
  read(indexfile,indrec);
  Wordsfile_deleterecord(indrec.Recordpos);
end;

procedure savechanges(var rec:tWordsrec);
var
indrec:tindexrec;
begin
  seek(indexfile,indexfile_findrecord(rec.label1));
  read(indexfile,indrec);
  seek(Wordsfile,indrec.recordpos);
  write(Wordsfile,rec);
end;

{fonction modifie pour retourner un boolen, au lieu d'1 TWordsrec}
//function findrecord(name: string25):TWordsrec;
function findrecord(name: string25): boolean;
var
  indrec:Tindexrec;
  indpos:longint;
  temp:tWordsrec;
begin
  temp.label1:='';
{  temp.postcode:='';
  temp.telNo:='';}
  indpos := indexfile_findrecord(name);
  if indpos <> -1 then
{  begin
    seek(indexfile,indpos);
    read(indexfile,indrec);
    seek(Wordsfile,indrec.recordpos);
    read(Wordsfile,temp);
  end}
  result := true
  else
{    begin
      showmessage('Record not found');
    end;
  result:=temp;}
  result := false;
end;

Procedure done;
begin
  closefile(indexfile);
  closefile(delfile);
  closefile(Wordsfile);
end;

end.
