unit cDBNavigator;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, DBCtrls;

type
  TcDBNavigator = class(TDBNavigator)
  private
    { Private declarations }
    fnbFirst: TNotifyEvent;
    fnbPrior: TNotifyEvent;
    fnbNext: TNotifyEvent;
    fnbLast: TNotifyEvent;
    fnbInsert: TNotifyEvent;
    fnbDelete: TNotifyEvent;
    fnbEdit: TNotifyEvent;
    fnbPost: TNotifyEvent;
    fnbCancel: TNotifyEvent;
    fnbRefresh: TNotifyEvent;
    procedure DonbFirst(Sender: TObject);
    procedure DonbPrior(Sender: TObject);
    procedure DonbNext(Sender: TObject);
    procedure DonbLast(Sender: TObject);
    procedure DonbInsert(Sender: TObject);
    procedure DonbDelete(Sender: TObject);
    procedure DonbEdit(Sender: TObject);
    procedure DonbPost(Sender: TObject);
    procedure DonbCancel(Sender: TObject);
    procedure DonbRefresh(Sender: TObject);
  protected
    { Protected declarations }
    procedure Loaded; override;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
  published
    { Published declarations }
    property OnFirst: TNotifyEvent read fnbFirst write fnbFirst;
    property OnPrior: TNotifyEvent read fnbPrior write fnbPrior;
    property OnNext: TNotifyEvent read fnbNext write fnbNext;
    property OnLast: TNotifyEvent read fnbLast write fnbLast;
    property OnInsert: TNotifyEvent read fnbInsert write fnbInsert;
    property OnDelete: TNotifyEvent read fnbDelete write fnbDelete;
    property OnEdit: TNotifyEvent read fnbEdit write fnbEdit;
    property OnPost: TNotifyEvent read fnbPost write fnbPost;
    property OnCancel: TNotifyEvent read fnbCancel write fnbCancel;
    property OnRefresh: TNotifyEvent read fnbRefresh write fnbRefresh;
  end;

//procedure Register;

implementation

constructor TcDBNavigator.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  fnbFirst := Buttons[nbFirst].OnClick;
  Buttons[nbFirst].OnClick := DonbFirst;
  fnbPrior := Buttons[nbPrior].OnClick;
  Buttons[nbPrior].OnClick := DonbPrior;
  fnbNext := Buttons[nbNext].OnClick;
  Buttons[nbNext].OnClick := DonbNext;
  fnbLast := Buttons[nbLast].OnClick;
  Buttons[nbLast].OnClick := DonbLast;
  fnbInsert := Buttons[nbInsert].OnClick;
  Buttons[nbInsert].OnClick := DonbInsert;
  fnbDelete := Buttons[nbDelete].OnClick;
  Buttons[nbDelete].OnClick := DonbDelete;
  fnbEdit := Buttons[nbEdit].OnClick;
  Buttons[nbEdit].OnClick := DonbEdit;
  fnbPost := Buttons[nbPost].OnClick;
  Buttons[nbPost].OnClick := DonbPost;
  fnbCancel := Buttons[nbCancel].OnClick;
  Buttons[nbCancel].OnClick := DonbCancel;
  fnbRefresh := Buttons[nbRefresh].OnClick;
  Buttons[nbRefresh].OnClick := DonbRefresh;
end;

procedure TcDBNavigator.DonbFirst(Sender: TObject);
begin
  if assigned(fnbFirst) then fnbFirst(Sender);
end;

procedure TcDBNavigator.DonbPrior(Sender: TObject);
begin
  if assigned(fnbPrior) then fnbPrior(Sender);
end;

procedure TcDBNavigator.DonbNext(Sender: TObject);
begin
  if assigned(fnbNext) then fnbNext(Sender);
end;

procedure TcDBNavigator.DonbLast(Sender: TObject);
begin
  if assigned(fnbLast) then fnbLast(Sender);
end;

procedure TcDBNavigator.DonbInsert(Sender: TObject);
begin
  if assigned(fnbInsert) then fnbInsert(Sender);
end;

procedure TcDBNavigator.DonbDelete(Sender: TObject);
begin
  if assigned(fnbDelete) then fnbDelete(Sender);
end;

procedure TcDBNavigator.DonbEdit(Sender: TObject);
begin
  if assigned(fnbEdit) then fnbEdit(Sender);
end;

procedure TcDBNavigator.DonbPost(Sender: TObject);
begin
  if assigned(fnbPost) then fnbPost(Sender);
end;

procedure TcDBNavigator.DonbCancel(Sender: TObject);
begin
  if assigned(fnbCancel) then fnbCancel(Sender);
end;

procedure TcDBNavigator.DonbRefresh(Sender: TObject);
begin
  if assigned(fnbRefresh) then fnbRefresh(Sender);
end;

{permet de rendre enable le boutons, mme si le dataset n'existe pas}
procedure TcDBNavigator.Loaded;
var
  I: TNavigateBtn;
begin
    inherited;
    for I := Low(Buttons) to High(Buttons) do
      Buttons[I].Enabled := True;
end;

{procedure Register;
begin
  RegisterComponents('Exemples', [TcDBNavigator]);
end;}

end.

